diff --git a/drupal7/sites/all/modules/file_entity/file_entity.test b/drupal7/sites/all/modules/file_entity/file_entity.test
index 4cc4b9a7..2c72cbd8 100644
--- a/drupal7/sites/all/modules/file_entity/file_entity.test
+++ b/drupal7/sites/all/modules/file_entity/file_entity.test
@@ -6,8 +6,6 @@
  */
 
 class FileEntityTestHelper extends DrupalWebTestCase {
-  protected $files = array();
-
   function setUp() {
     $modules = func_get_args();
     if (isset($modules[0]) && is_array($modules[0])) {
@@ -17,88 +15,6 @@ class FileEntityTestHelper extends DrupalWebTestCase {
     parent::setUp($modules);
   }
 
-  protected function setUpFiles($defaults = array()) {
-    // Populate defaults array.
-    $defaults += array(
-      'uid' => 1,
-      'status' => FILE_STATUS_PERMANENT,
-    );
-
-    $types = array('text', 'image');
-    foreach ($types as $type) {
-      foreach ($this->drupalGetTestFiles($type) as $file) {
-        foreach ($defaults as $key => $value) {
-          $file->$key = $value;
-        }
-        $this->files[$type][] = file_save($file);
-      }
-    }
-  }
-
-  protected function createFileType($overrides = array()) {
-    $type = new stdClass();
-    $type->type = 'test';
-    $type->label = "Test";
-    $type->description = '';
-    $type->mimetypes = array('image/jpeg', 'image/gif', 'image/png', 'image/tiff');
-
-    foreach ($overrides as $k => $v) {
-      $type->$k = $v;
-    }
-
-    file_type_save($type);
-    return $type;
-  }
-
-  /**
-   * Helper for testFileEntityPrivateDownloadAccess() test.
-   *
-   * Defines several cases for accesing private files.
-   *
-   * @return array
-   *   Array of associative arrays, each one having the next keys:
-   *   - "message" string with the assertion message.
-   *   - "permissions" array of permissions or NULL for anonymous user.
-   *   - "expect" expected HTTP response code.
-   *   - "owner" Optional boolean indicating if the user is a file owner.
-   */
-  protected function getPrivateDownloadAccessCases() {
-    return array(
-      array(
-        'message' => "File owners cannot download their own files unless they are granted the 'view own private files' permission.",
-        'permissions' => array(),
-        'expect' => 403,
-        'owner' => TRUE,
-      ),
-      array(
-        'message' => "File owners can download their own files as they have been granted the 'view own private files' permission.",
-        'permissions' => array('view own private files'),
-        'expect' => 200,
-        'owner' => TRUE,
-      ),
-      array(
-        'message' => "Anonymous users cannot download private files.",
-        'permissions' => NULL,
-        'expect' => 403,
-      ),
-      array(
-        'message' => "Authenticated users cannot download each other's private files.",
-        'permissions' => array(),
-        'expect' => 403,
-      ),
-      array(
-        'message' => "Users who can view public files are not able to download private files.",
-        'permissions' => array('view files'),
-        'expect' => 403,
-      ),
-      array(
-        'message' => "Users who bypass file access can download any file.",
-        'permissions' => array('bypass file access'),
-        'expect' => 200,
-      ),
-    );
-  }
-
   /**
    * Retrieves a sample file of the specified type.
    */
@@ -112,6 +28,13 @@ class FileEntityTestHelper extends DrupalWebTestCase {
     return $file;
   }
 
+  /**
+   * Retrieves the fid of the last inserted file.
+   */
+  function getLastFileId() {
+    return (int) db_query('SELECT MAX(fid) FROM {file_managed}')->fetchField();
+  }
+
   /**
    * Get a file from the database based on its filename.
    *
@@ -131,8 +54,6 @@ class FileEntityTestHelper extends DrupalWebTestCase {
   }
 
   protected function createFileEntity($settings = array()) {
-    $file = new stdClass();
-
     // Populate defaults array.
     $settings += array(
       'filepath' => 'Файл для тестирования ' . $this->randomName(), // Prefix with non-latin characters to ensure that all file-related tests work with international filenames.
@@ -181,6 +102,21 @@ class FileEntityTestHelper extends DrupalWebTestCase {
     return $file;
   }
 
+  protected function createFileType($overrides = array()) {
+    $type = new stdClass();
+    $type->type = 'test';
+    $type->label = "Test";
+    $type->description = '';
+    $type->mimetypes = array('image/jpeg', 'image/gif', 'image/png', 'image/tiff');
+
+    foreach ($overrides as $k => $v) {
+      $type->$k = $v;
+    }
+
+    file_type_save($type);
+    return $type;
+  }
+
   /**
    * Overrides DrupalWebTestCase::drupalGetToken() to support the hash salt.
    *
@@ -192,6 +128,9 @@ class FileEntityTestHelper extends DrupalWebTestCase {
   }
 }
 
+/**
+ * Tests file type classification functionality.
+ */
 class FileEntityFileTypeClassificationTestCase extends DrupalWebTestCase {
   public static function getInfo() {
     return array(
@@ -205,25 +144,6 @@ class FileEntityFileTypeClassificationTestCase extends DrupalWebTestCase {
     parent::setUp();
   }
 
-  /**
-   * Get the file type of a given file.
-   *
-   * @param $file
-   *   A file object.
-   *
-   * @return
-   *   The file's file type as a string.
-   */
-  function getFileType($file) {
-    $type = db_select('file_managed', 'fm')
-      ->fields('fm', array('type'))
-      ->condition('fid', $file->fid, '=')
-      ->execute()
-      ->fetchAssoc();
-
-    return $type;
-  }
-
   /**
    * Test that existing files are properly classified by file type.
    */
@@ -257,8 +177,30 @@ class FileEntityFileTypeClassificationTestCase extends DrupalWebTestCase {
     $file_type = $this->getFileType($image_file);
     $this->assertEqual($file_type['type'], 'image', t('The image file was properly assigned the Image file type.'));
   }
+
+  /**
+   * Get the file type of a given file.
+   *
+   * @param $file
+   *   A file object.
+   *
+   * @return
+   *   The file's file type as a string.
+   */
+  function getFileType($file) {
+    $type = db_select('file_managed', 'fm')
+      ->fields('fm', array('type'))
+      ->condition('fid', $file->fid, '=')
+      ->execute()
+      ->fetchAssoc();
+
+    return $type;
+  }
 }
 
+/**
+ * Tests basic file entity functionality.
+ */
 class FileEntityUnitTestCase extends FileEntityTestHelper {
   public static function getInfo() {
     return array(
@@ -268,11 +210,6 @@ class FileEntityUnitTestCase extends FileEntityTestHelper {
     );
   }
 
-  function setUp() {
-    parent::setUp();
-    $this->setUpFiles();
-  }
-
   /**
    * Regression tests for core issue http://drupal.org/node/1239376.
    */
@@ -289,8 +226,15 @@ class FileEntityUnitTestCase extends FileEntityTestHelper {
     }
   }
 
+  /**
+   * Tests basic file entity properties.
+   */
   function testFileEntity() {
-    $file = reset($this->files['text']);
+    // Save a raw file, turning it into a file entity.
+    $file = $this->getTestFile('text');
+    $file->uid = 1;
+    $file->status = FILE_STATUS_PERMANENT;
+    file_save($file);
 
     // Test entity ID, revision ID, and bundle.
     $ids = entity_extract_ids('file', $file);
@@ -301,58 +245,64 @@ class FileEntityUnitTestCase extends FileEntityTestHelper {
     $this->assertEqual($uri['path'], "file/{$file->fid}");
   }
 
+  /**
+   * Tests storing image height and width as file metadata.
+   */
   function testImageDimensions() {
-    $files = array();
-    $text_fids = array();
     // Test hook_file_insert().
-    // Files have been saved as part of setup (in FileEntityTestHelper::setUpFiles).
-    foreach ($this->files['image'] as $file) {
-      $files[$file->fid] = $file->metadata;
-      $this->assertTrue(isset($file->metadata['height']), 'Image height retrieved on file_save() for an image file.');
-      $this->assertTrue(isset($file->metadata['width']), 'Image width retrieved on file_save() for an image file.');
-    }
-    foreach ($this->files['text'] as $file) {
-      $text_fids[] = $file->fid;
-      $this->assertFalse(isset($file->metadata['height']), 'No image height retrieved on file_save() for an text file.');
-      $this->assertFalse(isset($file->metadata['width']), 'No image width retrieved on file_save() for an text file.');
-    }
+    $file = current($this->drupalGetTestFiles('image'));
+    $image_file = file_save($file);
+    $this->assertTrue(isset($image_file->metadata['height']), 'Image height retrieved on file_save() for an image file.');
+    $this->assertTrue(isset($image_file->metadata['width']), 'Image width retrieved on file_save() for an image file.');
+
+    $file = current($this->drupalGetTestFiles('text'));
+    $text_file = file_save($file);
+    $this->assertFalse(isset($text_file->metadata['height']), 'No image height retrieved on file_save() for an text file.');
+    $this->assertFalse(isset($text_file->metadata['width']), 'No image width retrieved on file_save() for an text file.');
 
     // Test hook_file_load().
     // Clear the cache and load fresh files objects to test file_load behavior.
     entity_get_controller('file')->resetCache();
-    foreach (file_load_multiple(array_keys($files)) as $file) {
-      $this->assertTrue(isset($file->metadata['height']), 'Image dimensions retrieved on file_load() for an image file.');
-      $this->assertTrue(isset($file->metadata['width']), 'Image dimensions retrieved on file_load() for an image file.');
-      $this->assertEqual($file->metadata['height'], $files[$file->fid]['height'], 'Loaded image height is equal to saved image height.');
-      $this->assertEqual($file->metadata['width'], $files[$file->fid]['width'], 'Loaded image width is equal to saved image width.');
-    }
-    foreach (file_load_multiple($text_fids) as $file) {
-      $this->assertFalse(isset($file->metadata['height']), 'No image height retrieved on file_load() for an text file.');
-      $this->assertFalse(isset($file->metadata['width']), 'No image width retrieved on file_load() for an text file.');
-    }
+
+    $file = file_load($image_file->fid);
+    $this->assertTrue(isset($file->metadata['height']), 'Image dimensions retrieved on file_load() for an image file.');
+    $this->assertTrue(isset($file->metadata['width']), 'Image dimensions retrieved on file_load() for an image file.');
+
+    $this->assertEqual($file->metadata['height'], $image_file->metadata['height'], 'Loaded image height is equal to saved image height.');
+    $this->assertEqual($file->metadata['width'], $image_file->metadata['width'], 'Loaded image width is equal to saved image width.');
+
+    $file = file_load($text_file->fid);
+    $this->assertFalse(isset($file->metadata['height']), 'No image height retrieved on file_load() for an text file.');
+    $this->assertFalse(isset($file->metadata['width']), 'No image width retrieved on file_load() for an text file.');
 
     // Test hook_file_update().
     // Load the first image file and resize it.
-    $image_files = array_keys($files);
-    $file = file_load(reset($image_files));
-    $image = image_load($file->uri);
-    image_resize($image, $file->metadata['width'] / 2, $file->metadata['height'] / 2);
+    $height = $image_file->metadata['width'] / 2;
+    $width = $image_file->metadata['height'] / 2;
+    $image = image_load($image_file->uri);
+    image_resize($image, $width, $height);
     image_save($image);
-    file_save($file);
-    $this->assertEqual($file->metadata['height'], $files[$file->fid]['height'] / 2, 'Image file height updated by file_save().');
-    $this->assertEqual($file->metadata['width'], $files[$file->fid]['width'] / 2, 'Image file width updated by file_save().');
+    file_save($image_file);
+
+    $this->assertEqual($image_file->metadata['height'], $height, 'Image file height updated by file_save().');
+    $this->assertEqual($image_file->metadata['width'], $width, 'Image file width updated by file_save().');
+
     // Clear the cache and reload the file.
     entity_get_controller('file')->resetCache();
-    $file = file_load($file->fid);
-    $this->assertEqual($file->metadata['height'], $files[$file->fid]['height'] / 2, 'Updated image height retrieved by file_load().');
-    $this->assertEqual($file->metadata['width'], $files[$file->fid]['width'] / 2, 'Updated image width retrieved by file_load().');
 
-    //Test hook_file_delete().
+    $file = file_load($image_file->fid);
+    $this->assertEqual($file->metadata['height'], $height, 'Updated image height retrieved by file_load().');
+    $this->assertEqual($file->metadata['width'], $width, 'Updated image width retrieved by file_load().');
+
+    // Verify that the image dimension metadata is removed on file deletion.
     file_delete($file, TRUE);
-    $this->assertFalse(db_query('SELECT COUNT(*) FROM {file_metadata} WHERE fid = :fid', array(':fid' => 'fid'))->fetchField(), 'Row deleted in {file_dimensions} on file_delete().');
+    $this->assertFalse(db_query('SELECT COUNT(*) FROM {file_metadata} WHERE fid = :fid', array(':fid' => 'fid'))->fetchField(), 'Row deleted in {file_metadata} on file_delete().');
   }
 }
 
+/**
+ * Tests editing existing file entities.
+ */
 class FileEntityEditTestCase extends FileEntityTestHelper {
   protected $web_user;
   protected $admin_user;
@@ -463,43 +413,228 @@ class FileEntityEditTestCase extends FileEntityTestHelper {
   }
 }
 
-class FileEntityCreationTestCase extends FileEntityTestHelper {
+/**
+ * Tests creating new file entities through the file upload wizard.
+ */
+class FileEntityUploadWizardTestCase extends FileEntityTestHelper {
   public static function getInfo() {
     return array(
-      'name' => 'File entity creation',
-      'description' => 'Create a file and test saving it.',
+      'name' => 'File entity upload wizard',
+      'description' => 'Upload a file using the multi-step wizard.',
       'group' => 'File entity',
+      'dependencies' => array('token'),
     );
   }
 
   function setUp() {
-    parent::setUp();
+    parent::setUp('token');
 
-    $web_user = $this->drupalCreateUser(array('create files', 'edit own document files'));
+    // Disable the private file system which is automatically enabled by
+    // DrupalTestCase so we can test the upload wizard correctly.
+    variable_del('file_private_path');
+
+    $web_user = $this->drupalCreateUser(array('create files', 'view own private files'));
     $this->drupalLogin($web_user);
   }
 
   /**
-   * Create a "document" file and verify its consistency in the database.
+   * Test the basic file upload wizard functionality.
    */
-  function testFileEntityCreation() {
+  function testFileEntityUploadWizardBasic() {
     $test_file = $this->getTestFile('text');
-    // Create a file.
+
+    // Step 1: Upload a basic document file.
     $edit = array();
     $edit['files[upload]'] = drupal_realpath($test_file->uri);
     $this->drupalPost('file/add', $edit, t('Next'));
 
-    // Step 2: Scheme selection
-    if ($this->xpath('//input[@name="scheme"]')) {
-      $this->drupalPost(NULL, array(), t('Next'));
-    }
+    // Check that the file exists in the database.
+    $fid = $this->getLastFileId();
+    $file = file_load($fid);
+    $this->assertTrue($file, t('File found in database.'));
 
     // Check that the document file has been uploaded.
-    $this->assertRaw(t('!type %name was uploaded.', array('!type' => 'Document', '%name' => $test_file->filename)), t('Document file uploaded.'));
+    $this->assertRaw(t('!type %name was uploaded.', array('!type' => 'Document', '%name' => $file->filename)), t('Document file uploaded.'));
+  }
+
+  /**
+   * Test the file upload wizard type step.
+   */
+  function testFileEntityUploadWizardTypes() {
+    $test_file = $this->getTestFile('text');
+
+    // Create multiple file types with the same mime types.
+    $this->createFileType(array('type' => 'document1', 'label' => 'Document 1', 'mimetypes' => array('text/plain')));
+    $this->createFileType(array('type' => 'document2', 'label' => 'Document 2', 'mimetypes' => array('text/plain')));
+
+    // Step 1: Upload a basic document file.
+    $edit = array();
+    $edit['files[upload]'] = drupal_realpath($test_file->uri);
+    $this->drupalPost('file/add', $edit, t('Next'));
+
+    // Step 2: File type selection.
+    $edit = array();
+    $edit['type'] = 'document2';
+    $this->drupalPost(NULL, $edit, t('Next'));
 
     // Check that the file exists in the database.
-    $file = $this->getFileByFilename($test_file->filename);
+    $fid = $this->getLastFileId();
+    $file = file_load($fid);
+    $this->assertTrue($file, t('File found in database.'));
+
+    // Check that the document file has been uploaded.
+    $this->assertRaw(t('!type %name was uploaded.', array('!type' => 'Document 2', '%name' => $file->filename)), t('Document 2 file uploaded.'));
+  }
+
+  /**
+   * Test the file upload wizard scheme step.
+   */
+  function testFileEntityUploadWizardSchemes() {
+    $test_file = $this->getTestFile('text');
+
+    // Enable the private file system.
+    variable_set('file_private_path', $this->private_files_directory);
+
+    // Step 1: Upload a basic document file.
+    $edit = array();
+    $edit['files[upload]'] = drupal_realpath($test_file->uri);
+    $this->drupalPost('file/add', $edit, t('Next'));
+
+    // Step 3: Scheme selection.
+    $edit = array();
+    $edit['scheme'] = 'private';
+    $this->drupalPost(NULL, $edit, t('Next'));
+
+    // Check that the file exists in the database.
+    $fid = $this->getLastFileId();
+    $file = file_load($fid);
+    $this->assertTrue($file, t('File found in database.'));
+
+    // Check that the document file has been uploaded.
+    $this->assertRaw(t('!type %name was uploaded.', array('!type' => 'Document', '%name' => $file->filename)), t('Document file uploaded.'));
+  }
+
+  /**
+   * Test the file upload wizard field step.
+   */
+  function testFileEntityUploadWizardFields() {
+    $test_file = $this->getTestFile('image');
+    $filename = $this->randomName();
+    $alt = $this->randomName();
+    $title = $this->randomName();
+
+    // Step 1: Upload a basic image file.
+    $edit = array();
+    $edit['files[upload]'] = drupal_realpath($test_file->uri);
+    $this->drupalPost('file/add', $edit, t('Next'));
+
+    // Step 4: Attached fields.
+    $edit = array();
+    $edit['filename'] = $filename;
+    $edit['field_file_image_alt_text[' . LANGUAGE_NONE . '][0][value]'] = $alt;
+    $edit['field_file_image_title_text[' . LANGUAGE_NONE . '][0][value]'] = $title;
+    $this->drupalPost(NULL, $edit, t('Save'));
+
+    // Check that the file exists in the database.
+    $fid = $this->getLastFileId();
+    $file = file_load($fid);
     $this->assertTrue($file, t('File found in database.'));
+
+    // Check that the image file has been uploaded.
+    $this->assertRaw(t('!type %name was uploaded.', array('!type' => 'Image', '%name' => $filename)), t('Image file uploaded.'));
+
+    // Check that the alt and title text was loaded from the fields.
+    $this->assertEqual($file->alt, $alt, t('Alt text was stored as file metadata.'));
+    $this->assertEqual($file->title, $title, t('Title text was stored as file metadata.'));
+  }
+
+  /**
+   * Test skipping each of the file upload wizard steps.
+   */
+  function testFileEntityUploadWizardStepSkipping() {
+    $test_file = $this->getTestFile('image');
+    $filename = $this->randomName();
+
+    // Ensure that the file is affected by every step.
+    variable_set('file_private_path', $this->private_files_directory);
+
+    $this->createFileType(array('type' => 'image1', 'label' => 'Image 1', 'mimetypes' => array('image/jpeg', 'image/gif', 'image/png', 'image/tiff')));
+    $this->createFileType(array('type' => 'image2', 'label' => 'Image 2', 'mimetypes' => array('image/jpeg', 'image/gif', 'image/png', 'image/tiff')));
+
+    $field_name = drupal_strtolower($this->randomName() . '_field_name');
+    $field = array('field_name' => $field_name, 'type' => 'text');
+    field_create_field($field);
+    $instance = array(
+      'field_name' => $field_name,
+      'entity_type' => 'file',
+      'bundle' => 'image2',
+      'label' => $this->randomName() . '_label',
+    );
+    field_create_instance($instance);
+
+    // Test skipping each upload wizard step.
+    foreach (array('types', 'schemes', 'fields') as $step) {
+      // Step to skip.
+      switch ($step) {
+        case 'types':
+          variable_set('file_entity_file_upload_wizard_skip_file_type', TRUE);
+          break;
+        case 'schemes':
+          variable_set('file_entity_file_upload_wizard_skip_scheme', TRUE);
+          break;
+        case 'fields':
+          variable_set('file_entity_file_upload_wizard_skip_fields', TRUE);
+          break;
+      }
+
+      // Step 1: Upload a basic image file.
+      $edit = array();
+      $edit['files[upload]'] = drupal_realpath($test_file->uri);
+      $this->drupalPost('file/add', $edit, t('Next'));
+
+      // Step 2: File type selection.
+      if ($step != 'types') {
+        $edit = array();
+        $edit['type'] = 'image2';
+        $this->drupalPost(NULL, $edit, t('Next'));
+      }
+
+      // Step 3: Scheme selection.
+      if ($step != 'schemes') {
+        $edit = array();
+        $edit['scheme'] = 'private';
+        $this->drupalPost(NULL, $edit, t('Next'));
+      }
+
+      // Step 4: Attached fields.
+      if ($step != 'fields') {
+        // Skipping file type selection essentially skips this step as well
+        // because the file will not be assigned a type so no fields will be
+        // available.
+        if ($step != 'types') {
+          $edit = array();
+          $edit['filename'] = $filename;
+          $edit[$field_name . '[' . LANGUAGE_NONE . '][0][value]'] = $this->randomName();
+          $this->drupalPost(NULL, $edit, t('Save'));
+        }
+      }
+
+      // Check that the file exists in the database.
+      $fid = $this->getLastFileId();
+      $file = file_load($fid);
+      $this->assertTrue($file, t('File found in database.'));
+
+      // Determine the file's file type.
+      $type = file_type_load($file->type);
+
+      // Check that the image file has been uploaded.
+      $this->assertRaw(t('!type %name was uploaded.', array('!type' => $type->label, '%name' => $file->filename)), t('Image file uploaded.'));
+
+      // Reset 'skip' variables.
+      variable_del('file_entity_file_upload_wizard_skip_file_type');
+      variable_del('file_entity_file_upload_wizard_skip_scheme');
+      variable_del('file_entity_file_upload_wizard_skip_fields');
+    }
   }
 }
 
@@ -585,11 +720,12 @@ class FileEntityAdminTestCase extends FileEntityTestHelper {
     $files['private_image'] = $this->createFileEntity(array('scheme' => 'private', 'uid' => $this->base_user_1->uid, 'type' => 'image'));
     $files['private_document'] = $this->createFileEntity(array('scheme' => 'private', 'uid' => $this->base_user_2->uid, 'type' => 'document'));
 
-    // Verify view, edit, and delete links for any file.
+    // Verify view, usage, edit, and delete links for any file.
     $this->drupalGet('admin/content/file');
     $this->assertResponse(200);
     foreach ($files as $file) {
       $this->assertLinkByHref('file/' . $file->fid);
+      $this->assertLinkByHref('file/' . $file->fid . '/usage');
       $this->assertLinkByHref('file/' . $file->fid . '/edit');
       $this->assertLinkByHref('file/' . $file->fid . '/delete');
       // Verify tableselect.
@@ -646,6 +782,7 @@ class FileEntityAdminTestCase extends FileEntityTestHelper {
     $this->assertResponse(200);
     foreach ($files as $file) {
       $this->assertLinkByHref('file/' . $file->fid);
+      $this->assertLinkByHref('file/' . $file->fid . '/usage');
       $this->assertLinkByHref('file/' . $file->fid . '/edit');
       $this->assertLinkByHref('file/' . $file->fid . '/delete');
     }
@@ -657,13 +794,194 @@ class FileEntityAdminTestCase extends FileEntityTestHelper {
     $this->assertResponse(200);
     foreach ($files as $file) {
       $this->assertLinkByHref('file/' . $file->fid);
+      $this->assertLinkByHref('file/' . $file->fid . '/usage');
       $this->assertLinkByHref('file/' . $file->fid . '/edit');
       $this->assertLinkByHref('file/' . $file->fid . '/delete');
     }
   }
 }
 
-class FileEntityReplaceTestCase extends FileEntityTestHelper {
+/**
+ * Tests the file usage page.
+ */
+class FileEntityUsageTestCase extends FileEntityTestHelper {
+  public static function getInfo() {
+    return array(
+      'name' => 'File entity usage',
+      'description' => 'Create a file and verify its usage.',
+      'group' => 'File entity',
+    );
+  }
+
+  function setUp() {
+    parent::setUp();
+
+    $web_user = $this->drupalCreateUser(array('create files', 'bypass file access', 'edit own article content'));
+    $this->drupalLogin($web_user);
+  }
+
+  /**
+   * Create a file and verify its usage information.
+   */
+  function testFileEntityUsagePage() {
+    $image_field = 'field_image';
+    $image = $this->getTestFile('image');
+
+    // Create a node, save it, then edit it to upload a file.
+    $edit = array(
+      "files[" . $image_field . "_" . LANGUAGE_NONE . "_0]" => drupal_realpath($image->uri),
+    );
+    $node = $this->drupalCreateNode(array('type' => 'article'));
+    $this->drupalPost('node/' . $node->nid . '/edit', $edit, t('Save'));
+
+    // Load the uploaded file.
+    $fid = $this->getLastFileId();
+    $file = file_load($fid);
+
+    // View the file's usage page.
+    $this->drupalGet('file/' . $file->fid . '/usage');
+
+    // Verify that a link to the entity is available.
+    $this->assertLink($node->title);
+    $this->assertLinkByHref('node/' . $node->nid);
+
+    // Verify that the entity type and use count information is also present.
+    $expected_values = array(
+      'type' => 'node',
+      'count' => 1,
+    );
+    foreach ($expected_values as $name => $value) {
+      $this->assertTrue($this->xpath('//table/tbody/tr/td[normalize-space(text())=:text]', array(':text' => $value)), t('File usage @name was found in the table.', array('@name' => $name)));
+    }
+
+    // Add a reference to the file from the same entity but registered by a
+    // different module to ensure that the usage count is incremented and no
+    // additional table rows are created.
+    file_usage_add($file, 'example_module', 'node', $node->nid, 2);
+
+    // Reload the page and verify that the expected values are present.
+    $this->drupalGet('file/' . $file->fid . '/usage');
+    $expected_values['count'] = 3;
+    foreach ($expected_values as $name => $value) {
+      $this->assertTrue($this->xpath('//table/tbody/tr/td[normalize-space(text())=:text]', array(':text' => $value)), t('File usage @name was found in the table.', array('@name' => $name)));
+    }
+
+    // Add a reference to the file from an entity that doesn't exist to ensure
+    // that this case is handled.
+    file_usage_add($file, 'test_module', 'imaginary', 1);
+
+    // Reload the page.
+    $this->drupalGet('file/' . $file->fid . '/usage');
+
+    // Verify that the module name is used in place of a link to the entity.
+    $this->assertNoLink('test_module');
+    $this->assertRaw('test_module', 'Module name used in place of link to the entity.');
+
+    // Verify that the entity type and use count information is also present.
+    $expected_values = array(
+      'type' => 'imaginary',
+      'count' => 1,
+    );
+    foreach ($expected_values as $name => $value) {
+      $this->assertTrue($this->xpath('//table/tbody/tr/td[normalize-space(text())=:text]', array(':text' => $value)), t('File usage @name was found in the table.', array('@name' => $name)));
+    }
+  }
+}
+
+/**
+ * Tests image alt and title text.
+ */
+class FileEntityAltTitleTestCase extends FileEntityTestHelper {
+  public static function getInfo() {
+    return array(
+      'name' => 'File entity alt and title text',
+      'description' => 'Create an image file with alt and title text.',
+      'group' => 'File entity',
+      'dependencies' => array('token'),
+    );
+  }
+
+  function setUp() {
+    parent::setUp('token');
+
+    $web_user = $this->drupalCreateUser(array('create files', 'edit own image files'));
+    $this->drupalLogin($web_user);
+  }
+
+  /**
+   * Create an "image" file and verify its associated alt and title text.
+   */
+  function testFileEntityAltTitle() {
+    $test_file = $this->getTestFile('image');
+    $alt_field_name = 'field_file_image_alt_text'; // Name of the default alt text field added to the image file type.
+    $title_field_name = 'field_file_image_title_text'; // Name of the default title text field added to the image file type.
+
+    // Create a file.
+    $edit = array();
+    $edit['files[upload]'] = drupal_realpath($test_file->uri);
+    $this->drupalPost('file/add', $edit, t('Next'));
+
+    // Step 2: Scheme selection.
+    if ($this->xpath('//input[@name="scheme"]')) {
+      $this->drupalPost(NULL, array(), t('Next'));
+    }
+
+    // Step 3: Attached fields.
+    $alt = 'Quote&quot; Amp&amp; ' . 'Файл для тестирования ' . $this->randomName(); // Generate alt text containing HTML entities, spaces and non-latin characters.
+    $title = 'Quote&quot; Amp&amp; ' . 'Файл для тестирования ' . $this->randomName(); // Generate title text containing HTML entities, spaces and non-latin characters.
+
+    $edit = array();
+    $edit[$alt_field_name . '[' . LANGUAGE_NONE . '][0][value]'] = $alt;
+    $edit[$title_field_name . '[' . LANGUAGE_NONE . '][0][value]'] = $title;
+    $this->drupalPost(NULL, $edit, t('Save'));
+
+    // Check that the image file has been uploaded.
+    $this->assertRaw(t('!type %name was uploaded.', array('!type' => 'Image', '%name' => $test_file->filename)), t('Image file uploaded.'));
+
+    // Check that the file exists in the database.
+    $file = $this->getFileByFilename($test_file->filename);
+    $this->assertTrue($file, t('File found in database.'));
+
+    // Check that the alt and title text was loaded from the fields.
+    $this->assertEqual($file->alt, $alt, t('Alt text was stored as file metadata.'));
+    $this->assertEqual($file->title, $title, t('Title text was stored as file metadata.'));
+
+    // Verify that the alt and title text is present on the page.
+    $image_info = array(
+      'path' => $file->uri,
+      'alt' => $alt,
+      'title' => $title,
+      'width' => $file->width,
+      'height' => $file->height,
+    );
+    $default_output = theme('image', $image_info);
+    $this->assertRaw($default_output, 'Image displayed using user supplied alt and title attributes.');
+
+    // Verify that the alt and title text can be edited.
+    $new_alt = $this->randomName();
+    $new_title = $this->randomName();
+
+    $edit = array();
+    $edit[$alt_field_name . '[' . LANGUAGE_NONE . '][0][value]'] = $new_alt;
+    $edit[$title_field_name . '[' . LANGUAGE_NONE . '][0][value]'] = $new_title;
+    $this->drupalPost('file/' . $file->fid . '/edit', $edit, t('Save'));
+
+    $image_info = array(
+      'path' => $file->uri,
+      'alt' => $new_alt,
+      'title' => $new_title,
+      'width' => $file->width,
+      'height' => $file->height,
+    );
+    $default_output = theme('image', $image_info);
+    $this->assertRaw($default_output, 'Image displayed using updated alt and title attributes.');
+  }
+}
+
+/**
+ * Tests replacing the file associated with a file entity.
+ */
+class FileEntityReplaceTestCase extends FileEntityTestHelper {
   public static function getInfo() {
     return array(
       'name' => 'File replacement',
@@ -674,7 +992,6 @@ class FileEntityReplaceTestCase extends FileEntityTestHelper {
 
   function setUp() {
     parent::setUp();
-    $this->setUpFiles();
   }
 
   /**
